/* 闇市場 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class BrackMarket extends JFrame implements ActionListener {
	private class Container {
		Card item = null;
		Container prev = null, next = null;

		public Container(Card item, Container prev, Container next){
			this.item = item;
			this.prev = prev;
			this.next = next;
		}

		public Container(Card item){
			this.item = item;
			this.prev = this.next = this;
		}
	}

	private boolean addCard(Card o){
		if (ptr == null){
			ptr = new Container(o);
		} else {
			Container cont = new Container(o, ptr.prev, ptr);
			ptr.prev.next = cont;
			ptr.prev = cont;
		}
		count++;
		return true;
	}

	public void prev1() throws Exception {
		int showing = (ptr1 != null ? 1 : 0) + (ptr2 != null ? 1 : 0) + (ptr3 != null ? 1 : 0);
		switch (count){
			case 0:
				throw new Exception();
			case 1:
				ptr1 = ptr;
				ptr2 = ptr3 = null;
				break;
			case 2:
				ptr1 = ptr;
				ptr2 = ptr.next;
				ptr3 = null;
				break;
			default:
				Container leftMost = (ptr1 != null) ? ptr1 : (ptr2 != null) ? ptr2 : (ptr3 != null) ? ptr3 : ptr;
				if (ptr2 == null){
					ptr2 = ptr1;
				} else if (ptr1 != null){
					ptr3 = ptr2;
					ptr2 = ptr1;
				}
				ptr = ptr1 = leftMost.prev;
				break;
		}
		if (showing >= count) throw new Exception();
	}

	public void next1() throws Exception {
		int showing = (ptr1 != null ? 1 : 0) + (ptr2 != null ? 1 : 0) + (ptr3 != null ? 1 : 0);
		switch (count){
			case 0:
				throw new Exception();
			case 1:
				ptr1 = ptr;
				ptr2 = ptr3 = null;
				break;
			case 2:
				ptr1 = ptr;
				ptr2 = ptr.next;
				ptr3 = null;
				break;
			default:
				Container rightMost = (ptr3 != null) ? ptr3 : (ptr2 != null) ? ptr2 : (ptr1 != null) ? ptr1 : ptr.prev;
				if (ptr2 == null){
					ptr2 = ptr3;
				} else if (ptr3 != null){
					ptr1 = ptr2;
					ptr2 = ptr3;
				}
				ptr3 = rightMost.next;
				ptr = (ptr1 != null) ? ptr1 : (ptr2 != null) ? ptr2 : (ptr3 != null) ? ptr3 : ptr;
				break;
		}
		if (showing >= count) throw new Exception();
	}

	public void prev3() throws Exception {
		int showing = (ptr1 != null ? 1 : 0) + (ptr2 != null ? 1 : 0) + (ptr3 != null ? 1 : 0);
		switch (count){
			case 0:
				throw new Exception();
			case 1:
				ptr1 = ptr;
				ptr2 = ptr3 = null;
				break;
			case 2:
				ptr1 = ptr;
				ptr2 = ptr.next;
				ptr3 = null;
				break;
			default:
				Container leftMost = (ptr1 != null) ? ptr1 : (ptr2 != null) ? ptr2 : (ptr3 != null) ? ptr3 : ptr;
				ptr3 = leftMost.prev;
				ptr2 = ptr3.prev;
				ptr = ptr1 = ptr2.prev;
				break;
		}
		if (showing >= count) throw new Exception();
	}

	public void next3() throws Exception {
		int showing = (ptr1 != null ? 1 : 0) + (ptr2 != null ? 1 : 0) + (ptr3 != null ? 1 : 0);
		switch (count){
			case 0:
				throw new Exception();
			case 1:
				ptr1 = ptr;
				ptr2 = ptr3 = null;
				break;
			case 2:
				ptr1 = ptr;
				ptr2 = ptr.next;
				ptr3 = null;
				break;
			default:
				Container rightMost = (ptr3 != null) ? ptr3 : (ptr2 != null) ? ptr2 : (ptr1 != null) ? ptr1 : ptr.prev;
				ptr = ptr1 = rightMost.next;
				ptr2 = ptr1.next;
				ptr3 = ptr2.next;
				break;
		}
		if (showing >= count) throw new Exception();
	}

	public void remove1(){
		ptr1.next.prev = ptr1.prev;
		ptr1.prev.next = ptr1.next;
		if (ptr == ptr1) ptr = ptr1.next;
		ptr1 = null;
		if (--count == 0) ptr = null;
	}

	public void remove2(){
		ptr2.next.prev = ptr2.prev;
		ptr2.prev.next = ptr2.next;
		if (ptr == ptr2) ptr = ptr2.next;
		ptr2 = null;
		if (--count == 0) ptr = null;
	}

	public void remove3(){
		ptr3.next.prev = ptr3.prev;
		ptr3.prev.next = ptr3.next;
		if (ptr == ptr3) ptr = ptr3.next;
		ptr3 = null;
		if (--count == 0) ptr = null;
	}

	public void reflesh(){
		img1.removeAll(); img1.add(ptr1 == null ? createBackImg() : (CardImage)ptr1.item.cardImg.clone()); btnBuy1.setEnabled(ptr1 != null); img1.repaint();
		img2.removeAll(); img2.add(ptr2 == null ? createBackImg() : (CardImage)ptr2.item.cardImg.clone()); btnBuy2.setEnabled(ptr2 != null); img2.repaint();
		img3.removeAll(); img3.add(ptr3 == null ? createBackImg() : (CardImage)ptr3.item.cardImg.clone()); btnBuy3.setEnabled(ptr3 != null); img3.repaint();
		pack();
	}

	private JPanel createBackImg(){
		JPanel backImg = new JPanel(){
			public void paintComponent(Graphics g){
				super.paintComponent(g);
				g.drawImage(DominionSupply.imgBack, 10, 10, null);
			}
		};
		backImg.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
		backImg.setBackground(Color.GRAY);
		backImg.setPreferredSize(new Dimension(20 + DominionSupply.imgBack.getWidth(), 20 + DominionSupply.imgBack.getHeight()));
		return backImg;
	}

	private BrackMarket myself;
	private Container ptr = null, ptr1 = null, ptr2 = null, ptr3 = null;
	private int count = 0;
	private JPanel img1 = new JPanel(), img2 = new JPanel(), img3 = new JPanel();
	private JButton
		btnBuy1 = new JButton("購入"), btnBuy2 = new JButton("購入"), btnBuy3 = new JButton("購入"),
		btnPrev1 = new JButton("< 前の1枚"), btnNext1 = new JButton("次の1枚 >"),
		btnPrev3 = new JButton("<< 前の3枚"), btnNext3 = new JButton("次の3枚 >>");

	public BrackMarket(boolean bmRange){
		setTitle("闇市場");
		setLayout(new BorderLayout());
		getContentPane().setBackground(Color.WHITE);
		setResizable(false);
		getRootPane().setDefaultButton(btnNext3);

		myself = this;
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				if (JOptionPane.showConfirmDialog(myself, "この画面を閉じると現在の闇市場デッキは破棄されます。よろしいですか？", "闇市場を閉じる", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION){
					myself.dispose();
				}
			}
		});

		JPanel center = new JPanel(), south = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		add(center, BorderLayout.CENTER);
		center.setLayout(gbl);
		center.setOpaque(false);
		center.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		gbc.gridy = 0; gbc.ipadx = gbc.ipady = 0; gbc.weightx = gbc.weighty = 1.0;
		gbc.gridx = 0; gbl.setConstraints(img1, gbc); center.add(img1); img1.setOpaque(false);
		gbc.gridx = 1; gbl.setConstraints(img2, gbc); center.add(img2); img2.setOpaque(false);
		gbc.gridx = 2; gbl.setConstraints(img3, gbc); center.add(img3); img3.setOpaque(false);
		img1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0)); img1.setLayout(new BorderLayout()); img1.add(createBackImg());
		img2.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 0)); img2.setLayout(new BorderLayout()); img2.add(createBackImg());
		img3.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 0)); img3.setLayout(new BorderLayout()); img3.add(createBackImg());
		gbc.gridy = 1;
		gbc.gridx = 0; gbl.setConstraints(btnBuy1, gbc); center.add(btnBuy1);
		gbc.gridx = 1; gbl.setConstraints(btnBuy2, gbc); center.add(btnBuy2); btnBuy2.setPreferredSize(new Dimension(50, 25));
		gbc.gridx = 2; gbl.setConstraints(btnBuy3, gbc); center.add(btnBuy3); btnBuy3.setPreferredSize(new Dimension(50, 25));
		btnBuy1.setPreferredSize(new Dimension(60, 25)); btnBuy1.setMargin(new Insets(0, 0, 0, 0));
		btnBuy2.setPreferredSize(new Dimension(60, 25)); btnBuy2.setMargin(new Insets(0, 0, 0, 0));
		btnBuy3.setPreferredSize(new Dimension(60, 25)); btnBuy3.setMargin(new Insets(0, 0, 0, 0));
		btnBuy1.addActionListener(this); btnBuy1.setEnabled(false);
		btnBuy2.addActionListener(this); btnBuy2.setEnabled(false);
		btnBuy3.addActionListener(this); btnBuy3.setEnabled(false);

		gbl = new GridBagLayout();
		add(south, BorderLayout.SOUTH);
		south.setLayout(gbl);
		south.setOpaque(false);
		south.setBorder(BorderFactory.createEmptyBorder(5, 10, 7, 10));
		gbc.gridx = 0; gbc.anchor = GridBagConstraints.WEST; gbc.insets = new Insets(0, 0, 0, 0);
		gbc.gridy = 0; gbl.setConstraints(btnPrev1, gbc); south.add(btnPrev1);
		gbc.gridy = 1; gbl.setConstraints(btnPrev3, gbc); south.add(btnPrev3);
		gbc.gridx = 1; gbc.anchor = GridBagConstraints.EAST; gbc.insets = new Insets(5, 0, 0, 0);
		gbc.gridy = 0; gbl.setConstraints(btnNext1, gbc); south.add(btnNext1);
		gbc.gridy = 1; gbl.setConstraints(btnNext3, gbc); south.add(btnNext3);
		btnPrev1.setPreferredSize(new Dimension(110, 25)); btnPrev1.setMargin(new Insets(0, 0, 0, 0));
		btnPrev3.setPreferredSize(new Dimension(110, 25)); btnPrev3.setMargin(new Insets(0, 0, 0, 0));
		btnNext1.setPreferredSize(new Dimension(110, 25)); btnNext1.setMargin(new Insets(0, 0, 0, 0));
		btnNext3.setPreferredSize(new Dimension(110, 25)); btnNext3.setMargin(new Insets(0, 0, 0, 0));
		btnPrev1.addActionListener(this);
		btnPrev3.addActionListener(this);
		btnNext1.addActionListener(this);
		btnNext3.addActionListener(this);

		RandomList<Card> random = new RandomList<Card>();
		if (bmRange){
			for (Expansion exp : Expansion.allInstances){
				if (!exp.isSelected()) continue;
				for (Card card : exp.cards) if (card.selected && !card.disabled) random.add(card);
			}
		} else {
			for (Expansion exp : Expansion.allInstances){
				if (!exp.isSelected()) continue;
				for (Card card : exp.cards) if (!card.disabled) random.add(card);
			}
		}
		while (!random.isEmpty()) addCard(random.randomRemove());

		pack();
		Rectangle screen = getGraphicsConfiguration().getBounds();
		setLocation(screen.x + screen.width / 2  - getSize().width / 2, screen.y + screen.height / 2 - getSize().height / 2);
	}


	public void actionPerformed(ActionEvent e){
		if (e.getSource() == btnBuy1){
			try {
				if (JOptionPane.showConfirmDialog(this, "「" + ptr1.item.name + "」が闇市場から取り除かれます", "購入", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE) == JOptionPane.OK_OPTION) remove1();
			} catch (Exception ex){}
			reflesh();
		} else if (e.getSource() == btnBuy2){
			try {
				if (JOptionPane.showConfirmDialog(this, "「" + ptr2.item.name + "」が闇市場から取り除かれます", "購入", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE) == JOptionPane.OK_OPTION) remove2();
			} catch (Exception ex){}
			reflesh();
		} else if (e.getSource() == btnBuy3){
			try {
				if (JOptionPane.showConfirmDialog(this, "「" + ptr3.item.name + "」が闇市場から取り除かれます", "購入", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE) == JOptionPane.OK_OPTION) remove3();
			} catch (Exception ex){}
			reflesh();
		} else {
			try {
				if (e.getSource() == btnPrev1){
					prev1();
				} else if (e.getSource() == btnNext1){
					next1();
				} else if (e.getSource() == btnPrev3){
					prev3();
				} else if (e.getSource() == btnNext3){
					next3();
				}
			} catch (Exception ex){
				JOptionPane.showMessageDialog(null, "闇市場にこれ以上カードは存在しません", "カード切れ", JOptionPane.ERROR_MESSAGE);
			}
			reflesh();
		}
	}
}
